<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>hydra-dict</title>
    <script src="https://unpkg.com/hydra-synth"></script>
</head>

<body>

    <script>

        const hydraCanvas = document.createElement("CANVAS");
        hydraCanvas.width = window.innerWidth / 2.;
        hydraCanvas.height = window.innerHeight / 2.;

        const hydra = new Hydra({
            detectAudio: false,
            canvas: hydraCanvas,
            numSources: 4,
            autoLoop: true,
            precision: 'highp',
            makeGlobal: true //en caso de utilizar local el ensamblador a cada generador debe agregarle "hydra." + osc... etc
        }).synth


        function ensamblar(operacion, args) {
            //https://stackoverflow.com/questions/11182924/how-to-check-if-javascript-object-is-json
            //quizas es muy mala practica pero si operacion es un array
            //ir recorriendo json internos ?? como poner los arg de cierre??
            if (args.constructor == Object) {
                console.log("hoy objetooo")
                //agregar una clausula de recorrer arrays dentro del obj?
                return operacion + "(" + ensamblar(args["operacion"], args["args"]) + ")";
            } else {
                return operacion + "(" + args.toString() + ")"
            };
        }
        //hydra.osc(50,1,0).kaleid(5).out()
        var string = "hydra."
        string += ensamblar("noise", [10, 1]) + ensamblar(".rotate", [0, .5])
        //".osc(30)";
        // string+=".rotate(.5,.1)";
        // string+=".pixelate()";
        string += ".out()";

        //https://developer.mozilla.org/es/docs/Web/JavaScript/Reference/Global_Objects/eval
        eval(string)

        var jsonsitos = [{
            "operacion": "shape",
            "args": [4, 0.5, 0.75]
        },
        {
            "operacion": ".repeat",
            "args": [3, 5]
        },
        {
            "operacion": ".mult",
            "args": {
                "operacion": "osc",
                "args": [3, .5, 1.]
            }
        },

        ]
        // var modulador = [//es altamente dificil anidar operaciones con este metodo
        //     {
        //         "operacion": ".modulateRotate",
        //         "args": [{
        //             "operacion": "src",
        //             "args": "o0"
        //         }, 15],
        //     },]
        //hydra.osc(50,1,0).kaleid(5).out()
        var str = ""// "hydra."

        for (var i = 0; i < jsonsitos.length; i++) {
            var temp = jsonsitos[i];
//tendria que hacer una func que solo reciva jsos 
//incluso una modalidad de lista??
            str += ensamblar(temp["operacion"], temp["args"]);
        }
        //considerar la apertura de blend y modulate
        var otrJson={
            "operacion":".modulateRotate",
            "args":[ "src(o0).rotate(0,0.01).scale(1.5).scrollY(()=>time).pixelate(120,40)", 15]

        }
        str += ensamblar(otrJson["operacion"], otrJson["args"]);

        str += ".out()";
        console.log(str)
        eval(str)

        //const hydra = new Hydra(opt).synth

        document.body.appendChild(hydraCanvas);
        const dict = {
            "osc": (a = 20, b = .1, c = 0) => osc(a, b, c),
            "noise": (a = 20, b = .1) => noise(a, b),
            "gradient": (a = 20, b = .1) => gradient(),
            "shape": (a = 8, b = .1, c = .5) => shape(a, b),
            "diff": (a, b, n = 1) => a.diff(b),
            "add": (a, b, n = 1) => a.add(b),
            "blend": (a, b, n = 1) => a.blend(b),
        }

        var valor = "gradient"
        //esto en un futuro de no poder avanzar con el objeto pasaria a ser un array de jsons y un for con algunos if 
        var listado = ["osc", "noise", "shape"]
        var otraLista = ["add", "blend", "diff"] //solo de prueba lo ideal seria un json x cada conjunto?
        //generar un metodo para substraer elementos a listado





    </script>
</body>

</html>